{% extends 'base/summarized.html' %}
{% load mathfilters %}

{% block base_title %}
    Tasks initialization
{% endblock %}


{% block content %}
    <div class="jumbotron">
        <div>
            <h1>Tasks generation</h1>
            <div class="lead">
                <span class="font-italic">Requesters</span> are looking for people able to resolve their <span class="font-italic">tasks.</span>
                <br>
                A <span class="font-italic">task</span> target a subset of workers with specific abilities.
            </div>
            <hr class="my-4">
        </div>

        <div>
            {% if object_list.count == 0 %}
                <div class="alert alert-info" role="alert">
                    No taks for now.
                    <hr>
                    Add a new task with the "Add Task" button or generate multiple tasks following a pattern with the "Generate tasks" button.
                </div>
            {% else %}
                <form method="get" class="d-inline-flex">
                    <div class="input-group">
                        <label for="tree" class="input-group-text">Filter by tree : </label>
                        <select class="form-control" name="tree">
                            <option value="all" selected>All</option>
                            {% for tree in trees %}
                                <option value="{{ tree.id }}">Tree : {{ tree.id }}</option>
                            {% endfor %}
                        </select>
                        <div class="input-group-append">
                            <button type="submit" class="btn btn-outline-primary">Filter</button>
                        </div>
                    </div>
                </form>

                {% include 'base/pagination.html' with page_obj=page_obj paginator=paginator%}

                <div class="row">
                    <div class="col-4">
                        <div class="list-group" id="myList" role="tablist">
                            {% for task in object_list %}
                                <a class="list-group-item list-group-item-action {% if task.id == object_list.0.id %}active{% endif %}" data-toggle="list" href="#t_{{ task.id }}" role="tab">
                                    {{ task.title }}
                                </a>
                            {% endfor %}
                        </div>
                    </div>

                    <div class="col-8">
                        <div class="tab-content">
                            {% for task in object_list %}
                                <div class="tab-pane {% if task.id == object_list.0.id %}active{% endif %}" id="t_{{ task.id }}" role="tabpanel">
                                    <div class="d-flex">
                                        <div class="p-2 font-weight-bold">
                                            {{ task.title }}
                                        </div>
                                        <div class="p-1 ml-auto">
                                            <a href="{% url 'tasks-del' task.id %}">
                                                <button class="btn btn-danger">
                                                    remove
                                                </button>
                                            </a>
                                        </div>
                                    </div>
                                    <hr>

                                    <div>
                                        <div class="p-2">
                                            <b>Tree :</b> <a href="{% url 'trees-get' task.tree.id %}">{{ task.tree.id }}</a>
                                        </div>
                                        <div class="p-2">
                                            <b>Description : </b> {{ task.descr }}
                                        </div>

                                        <div class="p-2">
                                            <b>Real number of workers :</b> {{ task.real_count }}
                                        </div>

                                        <div class="p-2">
                                            <b>Unperturbed number of workers (PKD without differential privacy): </b> {{ task.unpert_count }}
                                        </div>

                                        <div class="p-2">
                                            <b>Perturbed number of workers (PKD with differential privacy): </b> {{ task.pert_count }}
                                        </div>

                                        <div class="p-2">
                                            <b>Number of nodes : </b> {{ task.nodes }}
                                        </div>

                                        <hr>
                                    </div>

                                    <div>
                                        {% for tab in task.abilities.all %}
                                            <div class="row mt-2">
                                                <b class="col-sm-2">{{ tab.ability.name }} :</b>
                                                <div class="col-sm-10">
                                                    {% include 'base/display_area.html' with min=tab.level_min max=tab.level_max %}
                                                </div>
                                            </div>
                                        {% endfor %}
                                    </div>
                                </div>
                            {% endfor %}
                        </div>
                    </div>
                </div>
            {% endif %}
            <hr />
        </div>


        <div class="d-flex">
            <div class="p-2">
                <a href="{% url 'tasks-add' %}">
                    <button class="btn btn-primary">
                        Add task
                    </button>
                </a>
            </div>
            <div class="p-2 bd-highlight">
                <a href="{% url 'tasks-gen' %}">
                    <button class="btn btn-primary disabled" disabled data-toggle="tooltip" data-placement="top" title="Generate multiple tasks following a pattern">
                        Generate tasks
                    </button>
                </a>
            </div>

            {% if object_list.count is not 0 %}
                <div class="p-2 bd-highlight">
                    <a href="{% url 'tasks-del-all' %}">
                        <button class="btn btn-danger" data-toggle="tooltip" data-placement="top" title="Remove all tasks">
                            Remove all
                        </button>
                    </a>
                </div>
            {% endif %}

            <div class="p-2 ml-auto">
                <a href="{% url 'reset' %}" class="btn btn-primary">End (reset)</a>
            </div>
        </div>
    </div>

    <script>
        $('#myList a').on('click', function (e) {
            e.preventDefault()
            $(this).tab('show')
        })
    </script>
{% endblock %}
